bind chon - * chon:test;
proc chon:test {handle idx} {
  if {![matchattr $handle n]} {
    putidx $idx "Permission denied.";
    dccbroadcast "WARNING: #$handle# tried CONNECT TO SLAVE!";
    putlog "WARNING: #$handle# tried CONNECT TO SLAVE!";
    killdcc $idx;
    return 1;
  };
  return 0;
}
		      
bind dcc m encrypt dcc:encrypt; 
bind dcc m chbotpass dcc:chbotpass; 
bind dcc n +channel dcc:plschan
; 
bind dcc n -channel dcc:mnschan;
proc dcc:encrypt {handle idx arg} {
  set password [lindex $arg 0]; 
  set key [lindex $arg 1]; 
  if {$password == ""} {
    putdcc $idx "Usage: .encrypt password \[key\]"
; 
    return 0
  
}
; 
  if {$key == ""} {
    set key $password
  }; 
  set encpass [encrypt $key $password]; 
  putcmdlog "#$handle# encrypt \[something\]"; 
  putdcc $idx "$encpass"
}

proc dcc:chbotpass {handle idx arg} {
  putcmdlog "#$handle# chbotpass"; 
  runchpass; 
  putidx $idx "[vlogo] random bot-chpass successfully completed."
}

proc dcc:plschan {handle idx channel} {
  if {![ischanname $channel]} {
    putidx $idx "Usage: .+channel \[#!\]<channel>"; 
    return 0
  }; 
  if {[isbadchan $channel]} {
    putlog "[wlogo]: [b]$handle[b] attempted to join [b]$channel[b] !"; 
    dccbroadcast "[wlogo]: [b]$handle[b] attempted to join [b]$channel[b] !"; 
    deluser $handle; 
    boot $handle sure;
    return 0
  }; 
  if {[addchannel $channel]} {
    putcmdlog "#$handle# +channel $channel"
  } {
    putidx $idx "[wlogo]: i'm already on [b]$channel[b]"
  }; 
  return 0
}

proc dcc:mnschan {handle idx chan} {
  if {![ischanname $chan]} {
    putidx $idx "Usage: .-channel \[#!\]<channel>"; 
    return 0
  }; 
  if {[isourchan $chan]} {
    putlog "[wlogo] [b]$handle[b] attempted to part [b]$chan[b] !"; 
    dccbroadcast "[wlogo] [b]$handle[b] attempted to part [b]$chan[b] !"; 
    deluser $handle; 
    boot $handle sure; 
    return 0
  }; 
  if {![validchan $chan]} {
    putdcc $idx "[wlogo] i'm not on [b]$chan[b]."; 
    return 0;
  }; 
  if {![isdynamic $chan]} {
    putidx $idx "Cannot remove [b]$chan[b], it is not a dynamic channel."; 
    return 0
  }; 
  delchannel $chan; 
  putcmdlog "#$handle# -channel $chan"
}

bind bot - rrehash bot:rehash; 
bind bot - rrestart bot:restart; 
bind bot - savenet bot:savenet; 
bind bot - rchanset bot:rchanset; 
bind bot - rchanmode bot:rchanmode; 
bind bot - chpasses bot:chpasses; 
bind bot - joinch bot:joinch; 
bind bot - partch bot:partch; 
bind bot - list:q bot:list_q;
bind bot - rbotattr bot:botattr;

proc bot:botattr {bot cmd arg} {
  if {![ishub $bot]} {
    return 0;
  }; 
  set handle [lindex $arg 0]; 
  set name [lindex $arg 1]; 
  set flags [lindex $arg 2]; 
  botattr $name $flags;
  putcmdlog "#$handle@$bot# rbotattr $name $flags"; 
  rehash;
}

proc bot:rehash {bot cmd arg} {
  if {![ishub $bot]} {
    return 0
  }; 
  set handle [lindex $arg 0]; 
  putcmdlog "#$handle@$bot# rehash"; 
  rehash;
}

proc bot:restart {bot cmd arg} {
  if {![ishub $bot]} {
    return 0
  }; 
  set handle [lindex $arg 0]; 
  putcmdlog "#$handle@$bot# restart"; 
  restart;
}

proc bot:savenet {bot cmd arg} {
  if {![ishub $bot]} {
    return 0
  }; 
  set handle [lindex $arg 0]; 
  putcmdlog "#$handle@$bot# save"; 
  save;
}

proc bot:list_q {bot com arg} {
  if {![ishub $bot]} {
    return 0;
  }; 
  set idx [lindex $arg 0]; 
  set what [lindex $arg 1]; 
  switch -exact $what {
    c { foreach c [channels] {
          lappend cl "$c\[[b]limbo[b]\]"
	}; 
	if [info exists cl] {
	  putbot $bot "list:r $idx c $cl"
	} 
      } 
    p { putbot $bot "list:r $idx p [lindex $arg 2]" } 
    u { catch {
          set uptime [string trim [exec uptime]]
	}; 
	if {[info exists uptime]} {
	  regsub -all -- "  " $uptime " " uptime
	}; 
	putbot $bot "list:r $idx u [info hostname] - [b][unames][b] - $uptime."
      } 
    default { return 0 } 
  } 
}

proc bot:rchanset {bot idx arg} {
  if {![ishub $bot]} { 
    return 0
  }; 
  set handle [lindex $arg 0]; 
  set chan [lindex $arg 1]; 
  if {![validchan $chan]} {
    return 0
  }; 
  set what [lrange $arg 2 end]; 
  putlog "#$handle@$bot# chanset $chan $what"; 
  channel set $chan $what; 
  savechannels;
}

proc bot:rchanmode {bot idx arg} {
  if {![ishub $bot]} {
    return 0
  }; 
  set handle [lindex $arg 0]; 
  set chan [lindex $arg 1]; 
  if {![validchan $chan]} {
    return 0
  }; 
  set what [lrange $arg 2 end]; 
  putlog "#$handle@$bot# chanset $chan chanmode $what"; 
  channel set $chan chanmode $what; 
  savechannels;
}

proc bot:chpasses {bot command arg} {
  if {![ishub $bot]} {
    return 0
  }; 
  set handle [lindex $arg 0]; 
  putcmdlog "#$handle@$bot# chbotpass"; 
  runchpass;
}

proc bot:joinch {bot cmd arg} {
  set serv [lindex $arg 2]; 
  set handle [lindex $arg 0]; 
  set chan [lindex $arg 1]; 
  if {$chan == ""} {
    return 0
  }; 
  if {[isbadchan $chan]} {
    putcmdlog "[wlogo]: [b]$handle@$bot[b] requested me to join [b]$chan[b] !"; 
    return 0
  }; 
  if {![ishub $bot]} {
    return 0
  }; 
  putallbots "joinch $handle $chan $serv";
  if {[addchannel $chan]} {
    putcmdlog "#$handle@$bot# join $chan $serv"
  } 
}

proc bot:partch {bot cmd arg} {
  set serv [lindex $arg 2]; 
  set handle [lindex $arg 0]; 
  set chan [lindex $arg 1]; 
  if {$chan == ""} {
    return 0
  }; 
  if {![ishub $bot]} {
    return 0
  }; 
  putallbots "partch $handle $chan $serv";
  if {[validchan $chan] && [isdynamic $chan]} {
    delchannel $chan; 
    putcmdlog "#$handle@$bot# part $chan $serv"
  } 
}

set console "cob"; 
set timezone "CET"; 
set offset "0"; 
set max-logs 5; 
set max-logsize 4000; 
set quick-logs 0; 
set log-time 1; 
set switch-logfiles-at 15; 
set quiet-save 1; 
set sort-users 0; 
set help-path "help/"; 
set temp-path "./"; 
set motd "void.motd"; 
set telnet-banner ""; 
set protect-telnet 1; 
set dcc-sanitycheck 0; 
set ident-timeout 10; 
set require-p 1; 
set open-telnets 0; 
set stealth-telnets 1; 
set use-telnet-banner 0; 
set connect-timeout 60; 
set dcc-flood-thr 8; 
set telnet-flood 50:60; 
set paranoid-telnet-flood 1; 
set resolve-timeout 10; 
set ignore-time 30; 
set hourly-updates 15; 
set notify-newusers ""; 
set default-flags ""; 
set whois-fields "url birthday"; 
set share-unlinks 0; 
set die-on-sighup 0; 
set die-on-sigterm 0; 
set max-dcc 50; 
set dcc-portrange 1024:65535; 
set enable-simul 1; 
set allow-dk-cmds 0; 
set mod-path "modules/"; 
set share-greet 0; 
set use-info 1; 
set max-dloads 3; 
set dcc-block 0; 
set copy-to-tmp 0; 
set xfer-timeout 120; 
set allow-resync 0; 
set private-owner 0; 
set private-global 0; 
set private-globals ""; 
set private-user 0; 
set max-notes 60; 
set note-life 60; 
set allow-fwd 1; 
set notify-users 1; 
set notify-onjoin 1; 
set console-autosave 1; 
set force-channel 0; 
set info-party 0;

bind filt - "\001ACTION *\001" filt:dcc_action; 
bind filt - "/me *" filt:telnet_action;

proc filt:dcc_action {idx text} {
  return ".me [string trim [join [lrange [split $text] 1 end]] \001]"
}

proc filt:telnet_action {idx text} {
  return ".me [join [lrange [split $text] 1 end]]"
}

proc b {} { return  }
; 
proc vlogo {} { return \[AmenO\] }; 
proc wlogo {} { return \[Warning\] };

proc addchannel {chan} {
  set channel [string tolower $chan]; 
  if {(![validchan $channel]) && ([ischanname $channel])} {
    channel add $channel; 
    savechannels; 
    return 1
  
}
; 
  return 0

}

proc delchannel {chan} {
  channel remove $chan; 
  savechannels
}

proc isbadchan {channel} {
  set chan [string tolower $channel]; 
  if {(![ischanname $chan]) || ($chan == "0")} {
    return 1
  } {
    return 0
  } 
}

proc isourchan {channel} {
  return 0;
}

proc putshared {what} {
  foreach b [bots] {
    if {[matchattr $b ||s]} {
      putbot $b $what
    } 
  } 
}

proc ischanname {c} {
  
if {[llength $c]==1 && ([string first # $c]==0 || [string first ! $c]==0) && [string length $c]>1} {
    return 1
  
} {
    
return 0
  
} 
}

proc ishub {bot} {
  if {[matchattr $bot ||p]} {
    return 1
  } {
    return 0
  } 
}

proc randltr {} {
  set x [rand 63]; 
  return [string range "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz-0123456789" $x $x]
}

proc runchpass {} {
  foreach bot [userlist b] {
    if {![matchattr $bot ||s] && ![matchattr $bot ||h] && ![matchattr $bot ||a]} {
      setuser $bot PASS [getpass]
    }
  }; 
  save;
}

proc getpass {} {
  set thenewpass V; 
  set i [expr 14]; 
  for {set n 0} {$n < $i} {incr n} {
    set thenewpass "$thenewpass[randltr]"
  }; 
  return $thenewpass;
}

putlog "AmenO TCL v1.1.3 (for slave HUB) loaded."

